"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CsvGrape = void 0;
class CsvGrape {
    constructor(csvHandlerService) {
        this.csvHandlerService = csvHandlerService;
        this.response = { Content: {}, HasError: true, Headers: [], FileName: "", Index: 0 };
        this.content = { Data: this.response, Metadata: {} };
    }
    getCsvData(event) {
        return new Promise((resolve, reject) => {
            this.csvHandlerService.handleSingleFile(event).then((_response) => {
                resolve(_response);
            }, (err) => {
                reject(err);
            });
        });
    }
    getMetaData(csvRecordsArray, headersRow) {
        return this.csvHandlerService.getColumnDataTypes(csvRecordsArray, headersRow);
    }
    getCsvWithMetaData(event) {
        return new Promise((resolve, reject) => {
            this.csvHandlerService.handleSingleFile(event).then((_response) => {
                this.content.Data = _response;
                this.content.Metadata = this.csvHandlerService.getColumnDataTypes(_response.Content, _response.Headers);
                resolve(this.content);
            }, (err) => {
                reject(this.content);
            });
        });
    }
}
exports.CsvGrape = CsvGrape;
//# sourceMappingURL=csv-handler.js.map